package com.learning;

import com.learning.block.CustomBlocks;
import net.fabricmc.api.ModInitializer;

import net.fabricmc.fabric.api.registry.CompostingChanceRegistry;
import net.fabricmc.fabric.api.registry.FuelRegistryEvents;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.learning.item.CustomItems;
import com.learning.itemgroup.CustomItemGroup;

public class Learning implements ModInitializer {
	public static final String MOD_ID = "learning";

	// This logger is used to write text to the console and the log file.
	// It is considered best practice to use your mod id as the logger's name.
	// That way, it's clear which mod wrote info, warnings, and errors.
	public static final Logger LOGGER = LoggerFactory.getLogger(MOD_ID);

	@Override
	public void onInitialize() {
		// This code runs as soon as Minecraft is in a mod-load-ready state.
		// However, some things (like resources) may still be uninitialized.
		// Proceed with mild caution.

		LOGGER.info("Hello Fabric world!");
		CustomBlocks.registerBlocks();
        CustomItems.registerItems();
        CustomItemGroup.registerItemGroup();

		LOGGER.info("Adding Fuel registries...");
		FuelRegistryEvents.BUILD.register(((builder, context) -> {
			builder.add(CustomItems.OVERCOOKED_TOAST, 6000);
		}));

		LOGGER.info("Adding Compostable registries...");
		CompostingChanceRegistry.INSTANCE.add(CustomItems.TOAST, 0.3f);
		CompostingChanceRegistry.INSTANCE.add(CustomItems.BAKED_TOAST, 0.5f);
	}
}
