package com.learning.itemgroup;


import com.learning.Learning;
import com.learning.item.CustomItems;

import net.fabricmc.fabric.api.itemgroup.v1.ItemGroupEvents;
import net.minecraft.item.ItemGroup;
import net.minecraft.item.ItemGroups;
import net.minecraft.item.ItemStack;
import net.minecraft.registry.Registries;
import net.minecraft.registry.Registry;
import net.minecraft.text.Text;
import net.minecraft.util.Identifier;

public class CustomItemGroup {
    public static void registerItemGroup() {
    Learning.LOGGER.info("Registering ItemGroup...");
    Learning.LOGGER.info("Registering item into ItemGroups...");
    ItemGroupEvents.modifyEntriesEvent(ItemGroups.FOOD_AND_DRINK).register(
            register -> register.add(CustomItems.TOAST)
        );
    }

    public static ItemGroup customItemGroup = register("custom_itemgroup", ItemGroup.create(null, -1)
    .icon(() -> new ItemStack(CustomItems.TOAST))
    .displayName(Text.translatable("itemGroup.learning.custom_itemgroup"))
    .entries((displayContext, entries) -> {
            entries.add(CustomItems.TOAST);
            entries.add(CustomItems.BAKED_TOAST);
            entries.add(CustomItems.OVERCOOKED_TOAST);
            entries.add(CustomItems.DAMAGE_BLOCK);
            entries.add(CustomItems.TRANSFORM_BLOCK);
            entries.add(CustomItems.DENSITY_GLASS);
            entries.add(CustomItems.DENSITY_GLASS_DOOR);
            entries.add(CustomItems.DENSITY_GLASS_FENCE);
            entries.add(CustomItems.DENSITY_GLASS_FENCE_GATE);
            entries.add(CustomItems.DENSITY_GLASS_STAIRS);
            entries.add(CustomItems.DENSITY_GLASS_SLAB);
        })
    .build());

  private static ItemGroup register(String groupId, ItemGroup itemGroup) {
        return Registry.register(
            Registries.ITEM_GROUP, 
            Identifier.of(Learning.MOD_ID, groupId), 
            itemGroup);
    }
}
